// ***************************************************************************
// ***************************************************************************
// Rejeesh.Kutty@Analog.com (c) Analog Devices Inc.
// ***************************************************************************
// ***************************************************************************

#include <stdio.h>
#include "platform.h"
#include "xbasic_types.h"
#include "xstatus.h"
#include "xil_io.h"
#include "xparameters.h"
#include "xuartlite_l.h"

#define CF_BASEADDR   XPAR_CF_ADV7X11_CORE_0_BASEADDR
#define DDR_BASEADDR  XPAR_DDR3_SDRAM_S_AXI_BASEADDR
#define VDMA_BASEADDR XPAR_AXI_VDMA_0_BASEADDR
#define IIC_BASEADDR  XPAR_AXI_IIC_0_BASEADDR
#define UART_BASEADDR XPAR_RS232_UART_1_BASEADDR

#define TX_BASEADDR  DDR_BASEADDR + 0x1000000
#define RX_BASEADDR  DDR_BASEADDR + 0x0000000

#define H_TOTAL   2200
#define H_ACTIVE  1920
#define H_STRIDE  2048
#define V_TOTAL   1125
#define V_ACTIVE  1080

// ***************************************************************************
// ***************************************************************************

int main() {

  u32 v;
  u32 h;
  u32 waddr;
  u32 wdata;

  init_platform();
  xil_printf("programming DDR.\n\r");

  wdata = 0;

  for (v = 0; v < V_ACTIVE; v++) {
	  xil_printf("line %d.\n\r", v);
	  for (h = 0; h < H_ACTIVE; h++) {
		  waddr = TX_BASEADDR + (v*H_STRIDE*4) + (h*4);
		  Xil_Out32(waddr, wdata);
		  wdata = wdata + 1;
	  }
  }

  xil_printf("done.\n\r");
  cleanup_platform();
  return 0;
}


// ***************************************************************************
// ***************************************************************************

