#include <xparameters.h>
#include <xil_io.h>
#include "dma.h"

void DMA_TransferData(stTransferDescriptor* pCurrentDescriptor, stTransferDescriptor* pTailDescriptor)
{
	//stop DMA
	Xil_Out32((XPAR_AXIDMA_0_BASEADDR + 0x00), 0x00);
	//set the current descriptor pointer
	Xil_Out32((XPAR_AXIDMA_0_BASEADDR + 0x08), (u32)pCurrentDescriptor);
    //start DMA
	Xil_Out32((XPAR_AXIDMA_0_BASEADDR + 0x00), 0x01);
	//set the tail descriptor pointer
	Xil_Out32((XPAR_AXIDMA_0_BASEADDR + 0x10), (u32)pTailDescriptor);

}

u32 DMA_IsTransferComplete(void)
{
	return Xil_In32((XPAR_AXIDMA_0_BASEADDR + 0x04)) & 0x02;
}
