//--------------------------
//- spdif.h                - 
//-                        -
//-	Created on: 21.11.2011 -
//-	    Author: Alex Tofan -
//--------------------------

//------------------------------------------------------------------------------------------------
//------- Include Files --------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
#include "xil_types.h"

//------------------------------------------------------------------------------------------------
//------- SPDIF ----------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------
// Register address
#define SPDIF_TX_CONFIG             0x00
#define SPDIF_TX_CH_STAT            0x04
#define SPDIF_TX_INT_MASK           0x08
#define SPDIF_TX_INT_STAT           0x0C
#define SPDIF_USER_DATA_START       0x20
#define SPDIF_USER_DATA_STOP        0x37
#define SPDIF_CH_STATUS_START       0x40
#define SPDIF_CH_STATUS_STOP        0x57
// Register Specific Bits
// TxConfig Register
#define SPDIF_MODE                  20
//-------- Mode Settings --------------
    #define MODE_16                 0
    #define MODE_17                 1
    #define MODE_18                 2
    #define MODE_19                 3
    #define MODE_20                 4
    #define MODE_21                 5
    #define MODE_22                 6
    #define MODE_23                 7
    #define MODE_24                 8
//--------------------------------------    
#define SPDIF_RATIO                 8
#define SPDIF_UDATEN                6
#define SPDIF_CHSTEN                4
#define SPDIF_TINTEN                2
#define SPDIF_TXDATA                1
#define SPDIF_TXEN                  0
// TxChStat Register
#define SPDIF_FREQ                  6
#define SPDIF_GSTAT                 3
#define SPDIF_PREEM                 2
#define SPDIF_COPY                  1
#define SPDIF_AUDIO                 0
// TxIntMask Register
#define SPDIF_HCSBF_MSK             4
#define SPDIF_LCSBF_MSK             3
#define SPDIF_HSBF_MSK              1
#define SPDIF_LSBF_MSK              0
// TxIntStat Register
#define SPDIF_HCSBF_INT             4
#define SPDIF_LCSBF_INT             3
#define SPDIF_HSBF_INT              1
#define SPDIF_LSBF_INT              0
// User Data Register
#define SPDIF_CHBUD                 8
#define SPDIF_CHAUD                 0
// ChStat Register
#define SPDIF_CHBCS                 8
#define SPDIF_CHACS                 0
// Sample Data Register
#define SPDIF_DATH                  16
#define SPDIF_DATL                  0

void W_SPDIF_CONFIG(int value);
void W_SPDIF_CH_STAT(int value);
void W_SPDIF_INT_MASK(int value);
void W_SPDIF_INT_STAT(int value);
int R_SPDIF_CONFIG(void);
int R_SPDIF_CH_STAT(void);
int R_SPDIF_INT_MASK(void);
int R_SPDIF_INT_STAT(void);
void SPDIF_INIT(void);
void SPDIF_START(void);
void SPDIF_STOP(void);

